--clase disparo que hereda de padre
Disparo = setmetatable({}, Padre)

-- Making class 'Disparo' able to pass his methods to his instances
Disparo.__index = Disparo

local grafico = love.graphics.newImage("disparo.png")

function Disparo:new(x, y)
  local objeto = {
    x = x,
    y = y,
    velocidad = 300,
    parteAlta = 64,
  }

  -- after using the setmetatable function,
  -- the created object now will have all the methods from 'Disparo' class
  -- which are: update, draw, mover, eliminar
  -- And the methods from 'Padre' class
  setmetatable(objeto, self)

  -- object auto insert into the list
  objeto:insert()

  return objeto
end

function Disparo:update(dt)
  self:mover(dt)
  self:eliminar()
end

function Disparo:draw()
  love.graphics.draw(grafico, self.x, self.y, 0, 1, 1)
end

function Disparo:mover(dt)
  self.y = self.y - self.velocidad * dt
end

function Disparo:eliminar()
  if (self.y < self.parteAlta) then
    self:kill()
  end
end
