--clase jugador-----------------------------
Jugador = {}

-- Making class 'Jugador' able to pass his methods to his instances
Jugador.__index = Jugador

local grafico = love.graphics.newImage("jugador.png")

function Jugador:new(x, y)
  local objeto = {}

  -- self.imagen = grafico
  objeto.x = x or 320
  objeto.y = y or 380
  objeto.velocidad = 300

  -- here the created object will have access to all the methods from
  -- the class Jugador
  setmetatable(objeto, self)

  return objeto
end

function Jugador:update(dt)
  self:mover(dt)
  self:disparar(dt)
end

function Jugador:draw()
  love.graphics.draw(grafico, self.x, self.y, 0, 1, 1)
end

function Jugador:mover(dt)
  if (love.keyboard.isDown("left")) then
    self.x = self.x - self.velocidad * dt
  elseif (love.keyboard.isDown("right")) then
    self.x = self.x + self.velocidad * dt
  end

  if (love.keyboard.isDown("up")) then
    self.y = self.y - self.velocidad * dt
  elseif (love.keyboard.isDown("down")) then
    self.y = self.y + self.velocidad * dt
  end
end

function Jugador:disparar(dt)
  if (love.keyboard.isDown("z")) then
    Disparo:new(self.x + 45, self.y)
  end
end
